rc.subr revision 275359
1# $NetBSD: rc.subr,v 1.67 2006/10/07 11:25:15 elad Exp $
2# $FreeBSD: head/etc/rc.subr 275359 2014-12-01 12:17:42Z des $
3#
4# Copyright (c) 1997-2004 The NetBSD Foundation, Inc.
5# All rights reserved.
6#
7# This code is derived from software contributed to The NetBSD Foundation
8# by Luke Mewburn.
9#
10# Redistribution and use in source and binary forms, with or without
11# modification, are permitted provided that the following conditions
12# are met:
13# 1. Redistributions of source code must retain the above copyright
14#    notice, this list of conditions and the following disclaimer.
15# 2. Redistributions in binary form must reproduce the above copyright
16#    notice, this list of conditions and the following disclaimer in the
17#    documentation and/or other materials provided with the distribution.
18#
19# THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
20# ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
21# TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
22# PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
23# BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
24# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
25# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
26# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
27# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
28# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
29# POSSIBILITY OF SUCH DAMAGE.
30#
31# rc.subr
32#	functions used by various rc scripts
33#
34
35: ${RC_PID:=$$}; export RC_PID
36
37#
38#	Operating System dependent/independent variables
39#
40
41if [ -z "${_rc_subr_loaded}" ]; then
42
43_rc_subr_loaded="YES"
44
45SYSCTL="/sbin/sysctl"
46SYSCTL_N="${SYSCTL} -n"
47SYSCTL_W="${SYSCTL}"
48ID="/usr/bin/id"
49IDCMD="if [ -x $ID ]; then $ID -un; fi"
50PS="/bin/ps -ww"
51JID=`$PS -p $$ -o jid=`
52
53#
54#	functions
55#	---------
56
57# list_vars pattern
58#	List vars matching pattern.
59# 
60list_vars()
61{
62	set | { while read LINE; do
63		var="${LINE%%=*}"
64		case "$var" in
65		"$LINE"|*[!a-zA-Z0-9_]*) continue ;;
66		$1) echo $var
67		esac
68	done; }
69}
70
71# set_rcvar [var] [defval] [desc]
72#
73#	Echo or define a rc.conf(5) variable name.  Global variable
74#	$rcvars is used.
75#
76#	If no argument is specified, echo "${name}_enable".
77#
78#	If only a var is specified, echo "${var}_enable".
79#
80#	If var and defval are specified, the ${var} is defined as
81#	rc.conf(5) variable and the default value is ${defvar}.  An
82#	optional argument $desc can also be specified to add a
83#	description for that.
84#
85set_rcvar()
86{
87	local _var
88
89	case $# in
90	0)	echo ${name}_enable ;;
91	1)	echo ${1}_enable ;;
92	*)
93		debug "set_rcvar: \$$1=$2 is added" \
94		    " as a rc.conf(5) variable."
95		_var=$1
96		rcvars="${rcvars# } $_var"
97		eval ${_var}_defval=\"$2\"
98		shift 2
99		eval ${_var}_desc=\"$*\"
100	;;
101	esac
102}
103
104# set_rcvar_obsolete oldvar [newvar] [msg]
105#	Define obsolete variable.
106#	Global variable $rcvars_obsolete is used.
107#
108set_rcvar_obsolete()
109{
110	local _var
111	_var=$1
112	debug "set_rcvar_obsolete: \$$1(old) -> \$$2(new) is defined"
113
114	rcvars_obsolete="${rcvars_obsolete# } $1"
115	eval ${1}_newvar=\"$2\"
116	shift 2
117	eval ${_var}_obsolete_msg=\"$*\"
118}
119
120#
121# force_depend script [rcvar]
122#	Force a service to start. Intended for use by services
123#	to resolve dependency issues.
124#	$1 - filename of script, in /etc/rc.d, to run
125#	$2 - name of the script's rcvar (minus the _enable)
126#
127force_depend()
128{
129	local _depend _dep_rcvar
130
131	_depend="$1"
132	_dep_rcvar="${2:-$1}_enable"
133
134	[ -n "$rc_fast" ] && ! checkyesno always_force_depends &&
135	    checkyesno $_dep_rcvar && return 0
136
137	/etc/rc.d/${_depend} forcestatus >/dev/null 2>&1 && return 0
138
139	info "${name} depends on ${_depend}, which will be forced to start."
140	if ! /etc/rc.d/${_depend} forcestart; then
141		warn "Unable to force ${_depend}. It may already be running."
142		return 1
143	fi
144}
145
146#
147# checkyesno var
148#	Test $1 variable, and warn if not set to YES or NO.
149#	Return 0 if it's "yes" (et al), nonzero otherwise.
150#
151checkyesno()
152{
153	eval _value=\$${1}
154	debug "checkyesno: $1 is set to $_value."
155	case $_value in
156
157		#	"yes", "true", "on", or "1"
158	[Yy][Ee][Ss]|[Tt][Rr][Uu][Ee]|[Oo][Nn]|1)
159		return 0
160		;;
161
162		#	"no", "false", "off", or "0"
163	[Nn][Oo]|[Ff][Aa][Ll][Ss][Ee]|[Oo][Ff][Ff]|0)
164		return 1
165		;;
166	*)
167		warn "\$${1} is not set properly - see rc.conf(5)."
168		return 1
169		;;
170	esac
171}
172
173#
174# reverse_list list
175#	print the list in reverse order
176#
177reverse_list()
178{
179	_revlist=
180	for _revfile; do
181		_revlist="$_revfile $_revlist"
182	done
183	echo $_revlist
184}
185
186# stop_boot always
187#	If booting directly to multiuser or $always is enabled,
188#	send SIGTERM to the parent (/etc/rc) to abort the boot.
189#	Otherwise just exit.
190#
191stop_boot()
192{
193	local always
194
195	case $1 in
196		#	"yes", "true", "on", or "1"
197        [Yy][Ee][Ss]|[Tt][Rr][Uu][Ee]|[Oo][Nn]|1)
198		always=true
199		;;
200	*)
201		always=false
202		;;
203	esac
204	if [ "$autoboot" = yes -o "$always" = true ]; then
205		echo "ERROR: ABORTING BOOT (sending SIGTERM to parent)!"
206		kill -TERM ${RC_PID}
207	fi
208	exit 1
209}
210
211#
212# mount_critical_filesystems type
213#	Go through the list of critical filesystems as provided in
214#	the rc.conf(5) variable $critical_filesystems_${type}, checking
215#	each one to see if it is mounted, and if it is not, mounting it.
216#
217mount_critical_filesystems()
218{
219	eval _fslist=\$critical_filesystems_${1}
220	for _fs in $_fslist; do
221		mount | (
222			_ismounted=false
223			while read what _on on _type type; do
224				if [ $on = $_fs ]; then
225					_ismounted=true
226				fi
227			done
228			if $_ismounted; then
229				:
230			else
231				mount $_fs >/dev/null 2>&1
232			fi
233		)
234	done
235}
236
237#
238# check_pidfile pidfile procname [interpreter]
239#	Parses the first line of pidfile for a PID, and ensures
240#	that the process is running and matches procname.
241#	Prints the matching PID upon success, nothing otherwise.
242#	interpreter is optional; see _find_processes() for details.
243#
244check_pidfile()
245{
246	_pidfile=$1
247	_procname=$2
248	_interpreter=$3
249	if [ -z "$_pidfile" -o -z "$_procname" ]; then
250		err 3 'USAGE: check_pidfile pidfile procname [interpreter]'
251	fi
252	if [ ! -f $_pidfile ]; then
253		debug "pid file ($_pidfile): not readable."
254		return
255	fi
256	read _pid _junk < $_pidfile
257	if [ -z "$_pid" ]; then
258		debug "pid file ($_pidfile): no pid in file."
259		return
260	fi
261	_find_processes $_procname ${_interpreter:-.} '-p '"$_pid"
262}
263
264#
265# check_process procname [interpreter]
266#	Ensures that a process (or processes) named procname is running.
267#	Prints a list of matching PIDs.
268#	interpreter is optional; see _find_processes() for details.
269#
270check_process()
271{
272	_procname=$1
273	_interpreter=$2
274	if [ -z "$_procname" ]; then
275		err 3 'USAGE: check_process procname [interpreter]'
276	fi
277	_find_processes $_procname ${_interpreter:-.} '-ax'
278}
279
280#
281# _find_processes procname interpreter psargs
282#	Search for procname in the output of ps generated by psargs.
283#	Prints the PIDs of any matching processes, space separated.
284#
285#	If interpreter == ".", check the following variations of procname
286#	against the first word of each command:
287#		procname
288#		`basename procname`
289#		`basename procname` + ":"
290#		"(" + `basename procname` + ")"
291#		"[" + `basename procname` + "]"
292#
293#	If interpreter != ".", read the first line of procname, remove the
294#	leading #!, normalise whitespace, append procname, and attempt to
295#	match that against each command, either as is, or with extra words
296#	at the end.  As an alternative, to deal with interpreted daemons
297#	using perl, the basename of the interpreter plus a colon is also
298#	tried as the prefix to procname.
299#
300_find_processes()
301{
302	if [ $# -ne 3 ]; then
303		err 3 'USAGE: _find_processes procname interpreter psargs'
304	fi
305	_procname=$1
306	_interpreter=$2
307	_psargs=$3
308
309	_pref=
310	if [ $_interpreter != "." ]; then	# an interpreted script
311		_script="${_chroot}${_chroot:+/}$_procname"
312		if [ -r "$_script" ]; then
313			read _interp < $_script	# read interpreter name
314			case "$_interp" in
315			\#!*)
316				_interp=${_interp#\#!}	# strip #!
317				set -- $_interp
318				case $1 in
319				*/bin/env)
320					shift	# drop env to get real name
321					;;
322				esac
323				if [ $_interpreter != $1 ]; then
324					warn "\$command_interpreter $_interpreter != $1"
325				fi
326				;;
327			*)
328				warn "no shebang line in $_script"
329				set -- $_interpreter
330				;;
331			esac
332		else
333			warn "cannot read shebang line from $_script"
334			set -- $_interpreter
335		fi
336		_interp="$* $_procname"		# cleanup spaces, add _procname
337		_interpbn=${1##*/}
338		_fp_args='_argv'
339		_fp_match='case "$_argv" in
340		    ${_interp}|"${_interp} "*|"[${_interpbn}]"|"${_interpbn}: ${_procname}"*)'
341	else					# a normal daemon
342		_procnamebn=${_procname##*/}
343		_fp_args='_arg0 _argv'
344		_fp_match='case "$_arg0" in
345		    $_procname|$_procnamebn|${_procnamebn}:|"(${_procnamebn})"|"[${_procnamebn}]")'
346	fi
347
348	_proccheck="\
349		$PS 2>/dev/null -o pid= -o jid= -o command= $_psargs"' |
350		while read _npid _jid '"$_fp_args"'; do
351			'"$_fp_match"'
352				if [ "$JID" -eq "$_jid" ];
353				then echo -n "$_pref$_npid";
354				_pref=" ";
355				fi
356				;;
357			esac
358		done'
359
360#	debug "in _find_processes: proccheck is ($_proccheck)."
361	eval $_proccheck
362}
363
364# sort_lite [-b] [-n] [-k POS] [-t SEP]
365#	A lite version of sort(1) (supporting a few options) that can be used
366#	before the real sort(1) is available (e.g., in scripts that run prior
367#	to mountcritremote). Requires only shell built-in functionality.
368#
369sort_lite()
370{
371	local funcname=sort_lite
372	local sort_sep="$IFS" sort_ignore_leading_space=
373	local sort_field=0 sort_strict_fields= sort_numeric=
374	local nitems=0 skip_leading=0 trim=
375
376	local OPTIND flag
377	while getopts bnk:t: flag; do
378		case "$flag" in
379		b) sort_ignore_leading_space=1 ;;
380		n) sort_numeric=1 sort_ignore_leading_space=1 ;;
381		k) sort_field="${OPTARG%%,*}" ;; # only up to first comma
382			# NB: Unlike sort(1) only one POS allowed
383		t) sort_sep="$OPTARG"
384		   if [ ${#sort_sep} -gt 1 ]; then
385		   	echo "$funcname: multi-character tab \`$sort_sep'" >&2
386		   	return 1
387		   fi
388		   sort_strict_fields=1
389		   ;;
390		\?) return 1 ;;
391		esac
392	done
393	shift $(( $OPTIND - 1 ))
394
395	# Create transformation pattern to trim leading text if desired
396	case "$sort_field" in
397	""|[!0-9]*|*[!0-9.]*)
398		echo "$funcname: invalid sort field \`$sort_field'" >&2
399		return 1
400		;;
401	*.*)
402		skip_leading=${sort_field#*.} sort_field=${sort_field%%.*}
403		while [ ${skip_leading:-0} -gt 1 ] 2> /dev/null; do
404			trim="$trim?" skip_leading=$(( $skip_leading - 1 ))
405		done
406	esac
407
408	# Copy input to series of local numbered variables
409	# NB: IFS of NULL preserves leading whitespace
410	local LINE
411	while IFS= read -r LINE || [ "$LINE" ]; do
412		nitems=$(( $nitems + 1 ))
413		local src_$nitems="$LINE"
414	done
415
416	#
417	# Sort numbered locals using insertion sort
418	#
419	local curitem curitem_orig curitem_mod curitem_haskey
420	local dest dest_orig dest_mod dest_haskey
421	local d gt n
422	local i=1 
423	while [ $i -le $nitems ]; do
424		curitem_haskey=1 # Assume sort field (-k POS) exists
425		eval curitem=\"\$src_$i\"
426		curitem_mod="$curitem" # for modified comparison
427		curitem_orig="$curitem" # for original comparison
428
429		# Trim leading whitespace if desired
430		if [ "$sort_ignore_leading_space" ]; then
431			while case "$curitem_orig" in
432				[$IFS]*) : ;; *) false; esac
433			do
434				curitem_orig="${curitem_orig#?}"
435			done
436			curitem_mod="$curitem_orig"
437		fi
438
439		# Shift modified comparison value if sort field (-k POS) is > 1
440		n=$sort_field
441		while [ $n -gt 1 ]; do
442			case "$curitem_mod" in
443			*[$sort_sep]*)
444				# Cut text up-to (and incl.) first separator
445				curitem_mod="${curitem_mod#*[$sort_sep]}"
446
447				# Skip NULLs unless strict field splitting
448				[ "$sort_strict_fields" ] ||
449					[ "${curitem_mod%%[$sort_sep]*}" ] ||
450					[ $n -eq 2 ] ||
451					continue
452				;;
453			*)
454				# Asked for a field that doesn't exist
455				curitem_haskey= break
456			esac
457			n=$(( $n - 1 ))
458		done
459
460		# Trim trailing words if sort field >= 1
461		[ $sort_field -ge 1 -a "$sort_numeric" ] &&
462			curitem_mod="${curitem_mod%%[$sort_sep]*}"
463
464		# Apply optional trim (-k POS.TRIM) to cut leading characters
465		curitem_mod="${curitem_mod#$trim}"
466
467		# Determine the type of modified comparison to use initially
468		# NB: Prefer numerical if requested but fallback to standard
469		case "$curitem_mod" in
470		""|[!0-9]*) # NULL or begins with non-number
471			gt=">"
472			[ "$sort_numeric" ] && curitem_mod=0
473			;;
474		*)
475			if [ "$sort_numeric" ]; then
476				gt="-gt"
477				curitem_mod="${curitem_mod%%[!0-9]*}"
478					# NB: trailing non-digits removed
479					# otherwise numeric comparison fails
480			else
481				gt=">"
482			fi
483		esac
484
485		# If first time through, short-circuit below position-search
486		if [ $i -le 1 ]; then
487			d=0
488		else
489			d=1
490		fi
491
492		#
493		# Find appropriate element position
494		#
495		while [ $d -gt 0 ]
496		do
497			dest_haskey=$curitem_haskey
498			eval dest=\"\$dest_$d\"
499			dest_mod="$dest" # for modified comparison
500			dest_orig="$dest" # for original comparison
501
502			# Trim leading whitespace if desired
503			if [ "$sort_ignore_leading_space" ]; then
504				while case "$dest_orig" in
505					[$IFS]*) : ;; *) false; esac
506				do
507					dest_orig="${dest_orig#?}"
508				done
509				dest_mod="$dest_orig"
510			fi
511
512			# Shift modified value if sort field (-k POS) is > 1
513			n=$sort_field
514			while [ $n -gt 1 ]; do
515				case "$dest_mod" in
516				*[$sort_sep]*)
517					# Cut text up-to (and incl.) 1st sep
518					dest_mod="${dest_mod#*[$sort_sep]}"
519
520					# Skip NULLs unless strict fields
521					[ "$sort_strict_fields" ] ||
522					    [ "${dest_mod%%[$sort_sep]*}" ] ||
523					    [ $n -eq 2 ] ||
524					    continue
525					;;
526				*)
527					# Asked for a field that doesn't exist
528					dest_haskey= break
529				esac
530				n=$(( $n - 1 ))
531			done
532
533			# Trim trailing words if sort field >= 1
534			[ $sort_field -ge 1 -a "$sort_numeric" ] &&
535				dest_mod="${dest_mod%%[$sort_sep]*}"
536
537			# Apply optional trim (-k POS.TRIM), cut leading chars
538			dest_mod="${dest_mod#$trim}"
539
540			# Determine type of modified comparison to use
541			# NB: Prefer numerical if requested, fallback to std
542			case "$dest_mod" in
543			""|[!0-9]*) # NULL or begins with non-number
544				gt=">"
545				[ "$sort_numeric" ] && dest_mod=0
546				;;
547			*)
548				if [ "$sort_numeric" ]; then
549					gt="-gt"
550					dest_mod="${dest_mod%%[!0-9]*}"
551						# NB: kill trailing non-digits
552						# for numeric comparison safety
553				else
554					gt=">"
555				fi
556			esac
557
558			# Break if we've found the proper element position
559			if [ "$curitem_haskey" -a "$dest_haskey" ]; then
560				if [ "$dest_mod" = "$curitem_mod" ]; then
561					[ "$dest_orig" ">" "$curitem_orig" ] &&
562						break
563				elif [ "$dest_mod" $gt "$curitem_mod" ] \
564					2> /dev/null
565				then
566					break
567				fi
568			else
569				[ "$dest_orig" ">" "$curitem_orig" ] && break
570			fi
571
572			# Break if we've hit the end
573			[ $d -ge $i ] && break
574
575			d=$(( $d + 1 ))
576		done
577
578		# Shift remaining positions forward, making room for new item
579		n=$i
580		while [ $n -ge $d ]; do
581			# Shift destination item forward one placement
582			eval dest_$(( $n + 1 ))=\"\$dest_$n\"
583			n=$(( $n - 1 ))
584		done
585
586		# Place the element
587		if [ $i -eq 1 ]; then
588			local dest_1="$curitem"
589		else
590			local dest_$d="$curitem"
591		fi
592
593		i=$(( $i + 1 ))
594	done
595
596	# Print sorted results
597	d=1
598	while [ $d -le $nitems ]; do
599		eval echo \"\$dest_$d\"
600		d=$(( $d + 1 ))
601	done
602}
603
604#
605# wait_for_pids pid [pid ...]
606#	spins until none of the pids exist
607#
608wait_for_pids()
609{
610	local _list _prefix _nlist _j
611
612	_list="$@"
613	if [ -z "$_list" ]; then
614		return
615	fi
616	_prefix=
617	while true; do
618		_nlist="";
619		for _j in $_list; do
620			if kill -0 $_j 2>/dev/null; then
621				_nlist="${_nlist}${_nlist:+ }$_j"
622				[ -n "$_prefix" ] && sleep 1
623			fi
624		done
625		if [ -z "$_nlist" ]; then
626			break
627		fi
628		_list=$_nlist
629		echo -n ${_prefix:-"Waiting for PIDS: "}$_list
630		_prefix=", "
631		pwait $_list 2>/dev/null
632	done
633	if [ -n "$_prefix" ]; then
634		echo "."
635	fi
636}
637
638#
639# get_pidfile_from_conf string file
640#
641#	Takes a string to search for in the specified file.
642#	Ignores lines with traditional comment characters.
643#
644# Example:
645#
646# if get_pidfile_from_conf string file; then
647#	pidfile="$_pidfile_from_conf"
648# else
649#	pidfile='appropriate default'
650# fi
651#
652get_pidfile_from_conf()
653{
654	if [ -z "$1" -o -z "$2" ]; then
655		err 3 "USAGE: get_pidfile_from_conf string file ($name)"
656	fi
657
658	local string file line
659
660	string="$1" ; file="$2"
661
662	if [ ! -s "$file" ]; then
663		err 3 "get_pidfile_from_conf: $file does not exist ($name)"
664	fi
665
666	while read line; do
667		case "$line" in
668		*[#\;]*${string}*)	continue ;;
669		*${string}*)		break ;;
670		esac
671	done < $file
672
673	if [ -n "$line" ]; then
674		line=${line#*/}
675		_pidfile_from_conf="/${line%%[\"\;]*}"
676	else
677		return 1
678	fi
679}
680
681#
682# check_startmsgs
683#	If rc_quiet is set (usually as a result of using faststart at
684#	boot time) check if rc_startmsgs is enabled.
685#
686check_startmsgs()
687{
688	if [ -n "$rc_quiet" ]; then
689		checkyesno rc_startmsgs
690	else
691		return 0
692	fi
693}
694
695#
696# run_rc_command argument
697#	Search for argument in the list of supported commands, which is:
698#		"start stop restart rcvar status poll ${extra_commands}"
699#	If there's a match, run ${argument}_cmd or the default method
700#	(see below).
701#
702#	If argument has a given prefix, then change the operation as follows:
703#		Prefix	Operation
704#		------	---------
705#		fast	Skip the pid check, and set rc_fast=yes, rc_quiet=yes
706#		force	Set ${rcvar} to YES, and set rc_force=yes
707#		one	Set ${rcvar} to YES
708#		quiet	Don't output some diagnostics, and set rc_quiet=yes
709#
710#	The following globals are used:
711#
712#	Name		Needed	Purpose
713#	----		------	-------
714#	name		y	Name of script.
715#
716#	command		n	Full path to command.
717#				Not needed if ${rc_arg}_cmd is set for
718#				each keyword.
719#
720#	command_args	n	Optional args/shell directives for command.
721#
722#	command_interpreter n	If not empty, command is interpreted, so
723#				call check_{pidfile,process}() appropriately.
724#
725#	desc		n	Description of script.
726#
727#	extra_commands	n	List of extra commands supported.
728#
729#	pidfile		n	If set, use check_pidfile $pidfile $command,
730#				otherwise use check_process $command.
731#				In either case, only check if $command is set.
732#
733#	procname	n	Process name to check for instead of $command.
734#
735#	rcvar		n	This is checked with checkyesno to determine
736#				if the action should be run.
737#
738#	${name}_program	n	Full path to command.
739#				Meant to be used in /etc/rc.conf to override
740#				${command}.
741#
742#	${name}_chroot	n	Directory to chroot to before running ${command}
743#				Requires /usr to be mounted.
744#
745#	${name}_chdir	n	Directory to cd to before running ${command}
746#				(if not using ${name}_chroot).
747#
748#	${name}_flags	n	Arguments to call ${command} with.
749#				NOTE:	$flags from the parent environment
750#					can be used to override this.
751#
752#	${name}_env	n	Environment variables to run ${command} with.
753#
754#	${name}_fib	n	Routing table number to run ${command} with.
755#
756#	${name}_nice	n	Nice level to run ${command} at.
757#
758#	${name}_user	n	User to run ${command} as, using su(1) if not
759#				using ${name}_chroot.
760#				Requires /usr to be mounted.
761#
762#	${name}_group	n	Group to run chrooted ${command} as.
763#				Requires /usr to be mounted.
764#
765#	${name}_groups	n	Comma separated list of supplementary groups
766#				to run the chrooted ${command} with.
767#				Requires /usr to be mounted.
768#
769#	${name}_prepend	n	Command added before ${command}.
770#
771#	${rc_arg}_cmd	n	If set, use this as the method when invoked;
772#				Otherwise, use default command (see below)
773#
774#	${rc_arg}_precmd n	If set, run just before performing the
775#				${rc_arg}_cmd method in the default
776#				operation (i.e, after checking for required
777#				bits and process (non)existence).
778#				If this completes with a non-zero exit code,
779#				don't run ${rc_arg}_cmd.
780#
781#	${rc_arg}_postcmd n	If set, run just after performing the
782#				${rc_arg}_cmd method, if that method
783#				returned a zero exit code.
784#
785#	required_dirs	n	If set, check for the existence of the given
786#				directories before running a (re)start command.
787#
788#	required_files	n	If set, check for the readability of the given
789#				files before running a (re)start command.
790#
791#	required_modules n	If set, ensure the given kernel modules are
792#				loaded before running a (re)start command.
793#				The check and possible loads are actually
794#				done after start_precmd so that the modules
795#				aren't loaded in vain, should the precmd
796#				return a non-zero status to indicate a error.
797#				If a word in the list looks like "foo:bar",
798#				"foo" is the KLD file name and "bar" is the
799#				module name.  If a word looks like "foo~bar",
800#				"foo" is the KLD file name and "bar" is a
801#				egrep(1) pattern matching the module name.
802#				Otherwise the module name is assumed to be
803#				the same as the KLD file name, which is most
804#				common.  See load_kld().
805#
806#	required_vars	n	If set, perform checkyesno on each of the
807#				listed variables before running the default
808#				(re)start command.
809#
810#	Default behaviour for a given argument, if no override method is
811#	provided:
812#
813#	Argument	Default behaviour
814#	--------	-----------------
815#	start		if !running && checkyesno ${rcvar}
816#				${command}
817#
818#	stop		if ${pidfile}
819#				rc_pid=$(check_pidfile $pidfile $command)
820#			else
821#				rc_pid=$(check_process $command)
822#			kill $sig_stop $rc_pid
823#			wait_for_pids $rc_pid
824#			($sig_stop defaults to TERM.)
825#
826#	reload		Similar to stop, except use $sig_reload instead,
827#			and doesn't wait_for_pids.
828#			$sig_reload defaults to HUP.
829#			Note that `reload' isn't provided by default,
830#			it should be enabled via $extra_commands.
831#
832#	restart		Run `stop' then `start'.
833#
834#	status		Show if ${command} is running, etc.
835#
836#	poll		Wait for ${command} to exit.
837#
838#	rcvar		Display what rc.conf variable is used (if any).
839#
840#	enabled		Return true if the service is enabled.
841#
842#	Variables available to methods, and after run_rc_command() has
843#	completed:
844#
845#	Variable	Purpose
846#	--------	-------
847#	rc_arg		Argument to command, after fast/force/one processing
848#			performed
849#
850#	rc_flags	Flags to start the default command with.
851#			Defaults to ${name}_flags, unless overridden
852#			by $flags from the environment.
853#			This variable may be changed by the precmd method.
854#
855#	rc_pid		PID of command (if appropriate)
856#
857#	rc_fast		Not empty if "fast" was provided (q.v.)
858#
859#	rc_force	Not empty if "force" was provided (q.v.)
860#
861#	rc_quiet	Not empty if "quiet" was provided
862#
863#
864run_rc_command()
865{
866	_return=0
867	rc_arg=$1
868	if [ -z "$name" ]; then
869		err 3 'run_rc_command: $name is not set.'
870	fi
871
872	# Don't repeat the first argument when passing additional command-
873	# line arguments to the command subroutines.
874	#
875	shift 1
876	rc_extra_args="$*"
877
878	_rc_prefix=
879	case "$rc_arg" in
880	fast*)				# "fast" prefix; don't check pid
881		rc_arg=${rc_arg#fast}
882		rc_fast=yes
883		rc_quiet=yes
884		;;
885	force*)				# "force" prefix; always run
886		rc_force=yes
887		_rc_prefix=force
888		rc_arg=${rc_arg#${_rc_prefix}}
889		if [ -n "${rcvar}" ]; then
890			eval ${rcvar}=YES
891		fi
892		;;
893	one*)				# "one" prefix; set ${rcvar}=yes
894		_rc_prefix=one
895		rc_arg=${rc_arg#${_rc_prefix}}
896		if [ -n "${rcvar}" ]; then
897			eval ${rcvar}=YES
898		fi
899		;;
900	quiet*)				# "quiet" prefix; omit some messages
901		_rc_prefix=quiet
902		rc_arg=${rc_arg#${_rc_prefix}}
903		rc_quiet=yes
904		;;
905	esac
906
907	eval _override_command=\$${name}_program
908	command=${_override_command:-$command}
909
910	_keywords="start stop restart rcvar enabled $extra_commands"
911	rc_pid=
912	_pidcmd=
913	_procname=${procname:-${command}}
914
915					# setup pid check command
916	if [ -n "$_procname" ]; then
917		if [ -n "$pidfile" ]; then
918			_pidcmd='rc_pid=$(check_pidfile '"$pidfile $_procname $command_interpreter"')'
919		else
920			_pidcmd='rc_pid=$(check_process '"$_procname $command_interpreter"')'
921		fi
922		if [ -n "$_pidcmd" ]; then
923			_keywords="${_keywords} status poll"
924		fi
925	fi
926
927	if [ -z "$rc_arg" ]; then
928		rc_usage $_keywords
929	fi
930
931	if [ "$rc_arg" = "enabled" ] ; then
932		checkyesno ${rcvar}
933		return $?
934	fi
935
936	if [ -n "$flags" ]; then	# allow override from environment
937		rc_flags=$flags
938	else
939		eval rc_flags=\$${name}_flags
940	fi
941	eval _chdir=\$${name}_chdir	_chroot=\$${name}_chroot \
942	    _nice=\$${name}_nice	_user=\$${name}_user \
943	    _group=\$${name}_group	_groups=\$${name}_groups \
944	    _fib=\$${name}_fib		_env=\$${name}_env \
945	    _prepend=\$${name}_prepend
946
947	if [ -n "$_user" ]; then	# unset $_user if running as that user
948		if [ "$_user" = "$(eval $IDCMD)" ]; then
949			unset _user
950		fi
951	fi
952
953	[ -z "$autoboot" ] && eval $_pidcmd	# determine the pid if necessary
954
955	for _elem in $_keywords; do
956		if [ "$_elem" != "$rc_arg" ]; then
957			continue
958		fi
959					# if ${rcvar} is set, $1 is not "rcvar"
960					# and ${rc_pid} is not set, then run
961					#	checkyesno ${rcvar}
962					# and return if that failed
963					#
964		if [ -n "${rcvar}" -a "$rc_arg" != "rcvar" -a "$rc_arg" != "stop" ] ||
965		    [ -n "${rcvar}" -a "$rc_arg" = "stop" -a -z "${rc_pid}" ]; then
966			if ! checkyesno ${rcvar}; then
967				if [ -n "${rc_quiet}" ]; then
968					return 0
969				fi
970				echo -n "Cannot '${rc_arg}' $name. Set ${rcvar} to "
971				echo -n "YES in /etc/rc.conf or use 'one${rc_arg}' "
972				echo "instead of '${rc_arg}'."
973				return 0
974			fi
975		fi
976
977					# if there's a custom ${XXX_cmd},
978					# run that instead of the default
979					#
980		eval _cmd=\$${rc_arg}_cmd \
981		     _precmd=\$${rc_arg}_precmd \
982		     _postcmd=\$${rc_arg}_postcmd
983
984		if [ -n "$_cmd" ]; then
985			_run_rc_precmd || return 1
986			_run_rc_doit "$_cmd $rc_extra_args" || return 1
987			_run_rc_postcmd
988			return $_return
989		fi
990
991		case "$rc_arg" in	# default operations...
992
993		status)
994			_run_rc_precmd || return 1
995			if [ -n "$rc_pid" ]; then
996				echo "${name} is running as pid $rc_pid."
997			else
998				echo "${name} is not running."
999				return 1
1000			fi
1001			_run_rc_postcmd
1002			;;
1003
1004		start)
1005			if [ -z "$rc_fast" -a -n "$rc_pid" ]; then
1006				if [ -z "$rc_quiet" ]; then
1007					echo 1>&2 "${name} already running? " \
1008					    "(pid=$rc_pid)."
1009				fi
1010				return 1
1011			fi
1012
1013			if [ ! -x "${_chroot}${_chroot:+/}${command}" ]; then
1014				warn "run_rc_command: cannot run $command"
1015				return 1
1016			fi
1017
1018			if ! _run_rc_precmd; then
1019				warn "failed precmd routine for ${name}"
1020				return 1
1021			fi
1022
1023					# setup the full command to run
1024					#
1025			check_startmsgs && echo "Starting ${name}."
1026			if [ -n "$_chroot" ]; then
1027				_doit="\
1028${_nice:+nice -n $_nice }\
1029${_fib:+setfib -F $_fib }\
1030${_env:+env $_env }\
1031chroot ${_user:+-u $_user }${_group:+-g $_group }${_groups:+-G $_groups }\
1032$_chroot $command $rc_flags $command_args"
1033			else
1034				_doit="\
1035${_chdir:+cd $_chdir && }\
1036${_fib:+setfib -F $_fib }\
1037${_env:+env $_env }\
1038$command $rc_flags $command_args"
1039				if [ -n "$_user" ]; then
1040				    _doit="su -m $_user -c 'sh -c \"$_doit\"'"
1041				fi
1042				if [ -n "$_nice" ]; then
1043					if [ -z "$_user" ]; then
1044						_doit="sh -c \"$_doit\""
1045					fi
1046					_doit="nice -n $_nice $_doit"
1047				fi
1048				if [ -n "$_prepend" ]; then
1049					_doit="$_prepend $_doit"
1050				fi
1051			fi
1052
1053					# run the full command
1054					#
1055			if ! _run_rc_doit "$_doit"; then
1056				warn "failed to start ${name}"
1057				return 1
1058			fi
1059
1060					# finally, run postcmd
1061					#
1062			_run_rc_postcmd
1063			;;
1064
1065		stop)
1066			if [ -z "$rc_pid" ]; then
1067				[ -n "$rc_fast" ] && return 0
1068				_run_rc_notrunning
1069				return 1
1070			fi
1071
1072			_run_rc_precmd || return 1
1073
1074					# send the signal to stop
1075					#
1076			echo "Stopping ${name}."
1077			_doit=$(_run_rc_killcmd "${sig_stop:-TERM}")
1078			_run_rc_doit "$_doit" || return 1
1079
1080					# wait for the command to exit,
1081					# and run postcmd.
1082			wait_for_pids $rc_pid
1083
1084			_run_rc_postcmd
1085			;;
1086
1087		reload)
1088			if [ -z "$rc_pid" ]; then
1089				_run_rc_notrunning
1090				return 1
1091			fi
1092
1093			_run_rc_precmd || return 1
1094
1095			_doit=$(_run_rc_killcmd "${sig_reload:-HUP}")
1096			_run_rc_doit "$_doit" || return 1
1097
1098			_run_rc_postcmd
1099			;;
1100
1101		restart)
1102					# prevent restart being called more
1103					# than once by any given script
1104					#
1105			if ${_rc_restart_done:-false}; then
1106				return 0
1107			fi
1108			_rc_restart_done=true
1109
1110			_run_rc_precmd || return 1
1111
1112			# run those in a subshell to keep global variables
1113			( run_rc_command ${_rc_prefix}stop $rc_extra_args )
1114			( run_rc_command ${_rc_prefix}start $rc_extra_args )
1115			_return=$?
1116			[ $_return -ne 0 ] && [ -z "$rc_force" ] && return 1
1117
1118			_run_rc_postcmd
1119			;;
1120
1121		poll)
1122			_run_rc_precmd || return 1
1123			if [ -n "$rc_pid" ]; then
1124				wait_for_pids $rc_pid
1125			fi
1126			_run_rc_postcmd
1127			;;
1128
1129		rcvar)
1130			echo -n "# $name"
1131			if [ -n "$desc" ]; then
1132				echo " : $desc"
1133			else
1134				echo ""
1135			fi
1136			echo "#"
1137			# Get unique vars in $rcvar $rcvars
1138			for _v in $rcvar $rcvars; do
1139				case $v in
1140				$_v\ *|\ *$_v|*\ $_v\ *) ;;
1141				*)	v="${v# } $_v" ;;
1142				esac
1143			done
1144
1145			# Display variables.
1146			for _v in $v; do
1147				if [ -z "$_v" ]; then
1148					continue
1149				fi
1150
1151				eval _desc=\$${_v}_desc
1152				eval _defval=\$${_v}_defval
1153				_h="-"
1154
1155				eval echo \"$_v=\\\"\$$_v\\\"\"
1156				# decode multiple lines of _desc
1157				while [ -n "$_desc" ]; do
1158					case $_desc in
1159					*^^*)
1160						echo "# $_h ${_desc%%^^*}"
1161						_desc=${_desc#*^^}
1162						_h=" "
1163						;;
1164					*)
1165						echo "# $_h ${_desc}"
1166						break
1167						;;
1168					esac
1169				done
1170				echo "#   (default: \"$_defval\")"
1171			done
1172			echo ""
1173			;;
1174
1175		*)
1176			rc_usage $_keywords
1177			;;
1178
1179		esac
1180		return $_return
1181	done
1182
1183	echo 1>&2 "$0: unknown directive '$rc_arg'."
1184	rc_usage $_keywords
1185	# not reached
1186}
1187
1188#
1189# Helper functions for run_rc_command: common code.
1190# They use such global variables besides the exported rc_* ones:
1191#
1192#	name	       R/W
1193#	------------------
1194#	_precmd		R
1195#	_postcmd	R
1196#	_return		W
1197#
1198_run_rc_precmd()
1199{
1200	check_required_before "$rc_arg" || return 1
1201
1202	if [ -n "$_precmd" ]; then
1203		debug "run_rc_command: ${rc_arg}_precmd: $_precmd $rc_extra_args"
1204		eval "$_precmd $rc_extra_args"
1205		_return=$?
1206
1207		# If precmd failed and force isn't set, request exit.
1208		if [ $_return -ne 0 ] && [ -z "$rc_force" ]; then
1209			return 1
1210		fi
1211	fi
1212
1213	check_required_after "$rc_arg" || return 1
1214
1215	return 0
1216}
1217
1218_run_rc_postcmd()
1219{
1220	if [ -n "$_postcmd" ]; then
1221		debug "run_rc_command: ${rc_arg}_postcmd: $_postcmd $rc_extra_args"
1222		eval "$_postcmd $rc_extra_args"
1223		_return=$?
1224	fi
1225	return 0
1226}
1227
1228_run_rc_doit()
1229{
1230	debug "run_rc_command: doit: $*"
1231	eval "$@"
1232	_return=$?
1233
1234	# If command failed and force isn't set, request exit.
1235	if [ $_return -ne 0 ] && [ -z "$rc_force" ]; then
1236		return 1
1237	fi
1238
1239	return 0
1240}
1241
1242_run_rc_notrunning()
1243{
1244	local _pidmsg
1245
1246	if [ -n "$pidfile" ]; then
1247		_pidmsg=" (check $pidfile)."
1248	else
1249		_pidmsg=
1250	fi
1251	echo 1>&2 "${name} not running?${_pidmsg}"
1252}
1253
1254_run_rc_killcmd()
1255{
1256	local _cmd
1257
1258	_cmd="kill -$1 $rc_pid"
1259	if [ -n "$_user" ]; then
1260		_cmd="su -m ${_user} -c 'sh -c \"${_cmd}\"'"
1261	fi
1262	echo "$_cmd"
1263}
1264
1265#
1266# run_rc_script file arg
1267#	Start the script `file' with `arg', and correctly handle the
1268#	return value from the script.
1269#	If `file' ends with `.sh', it's sourced into the current environment
1270#	when $rc_fast_and_loose is set, otherwise it is run as a child process.
1271#	If `file' appears to be a backup or scratch file, ignore it.
1272#	Otherwise if it is executable run as a child process.
1273#
1274run_rc_script()
1275{
1276	_file=$1
1277	_arg=$2
1278	if [ -z "$_file" -o -z "$_arg" ]; then
1279		err 3 'USAGE: run_rc_script file arg'
1280	fi
1281
1282	unset	name command command_args command_interpreter \
1283		extra_commands pidfile procname \
1284		rcvar rcvars rcvars_obsolete required_dirs required_files \
1285		required_vars
1286	eval unset ${_arg}_cmd ${_arg}_precmd ${_arg}_postcmd
1287
1288	case "$_file" in
1289	/etc/rc.d/*.sh)			# no longer allowed in the base
1290		warn "Ignoring old-style startup script $_file"
1291		;;
1292	*[~#]|*.OLD|*.bak|*.orig|*,v)	# scratch file; skip
1293		warn "Ignoring scratch file $_file"
1294		;;
1295	*)				# run in subshell
1296		if [ -x $_file ]; then
1297			if [ -n "$rc_fast_and_loose" ]; then
1298				set $_arg; . $_file
1299			else
1300				( trap "echo Script $_file interrupted >&2 ; kill -QUIT $$" 3
1301				  trap "echo Script $_file interrupted >&2 ; exit 1" 2
1302				  trap "echo Script $_file running >&2" 29
1303				  set $_arg; . $_file )
1304			fi
1305		fi
1306		;;
1307	esac
1308}
1309
1310#
1311# load_rc_config name
1312#	Source in the configuration file for a given name.
1313#
1314load_rc_config()
1315{
1316	local _name _rcvar_val _var _defval _v _msg _new _d
1317	_name=$1
1318
1319	if ${_rc_conf_loaded:-false}; then
1320		:
1321	else
1322		if [ -r /etc/defaults/rc.conf ]; then
1323			debug "Sourcing /etc/defaults/rc.conf"
1324			. /etc/defaults/rc.conf
1325			source_rc_confs
1326		elif [ -r /etc/rc.conf ]; then
1327			debug "Sourcing /etc/rc.conf (/etc/defaults/rc.conf doesn't exist)."
1328			. /etc/rc.conf
1329		fi
1330		_rc_conf_loaded=true
1331	fi
1332
1333	# If a service name was specified, attempt to load
1334	# service-specific configuration
1335	if [ -n "$_name" ] ; then
1336		for _d in /etc ${local_startup%*/rc.d}; do
1337			if [ -f ${_d}/rc.conf.d/"$_name" ]; then
1338				debug "Sourcing ${_d}/rc.conf.d/$_name"
1339				. ${_d}/rc.conf.d/"$_name"
1340			elif [ -d ${_d}/rc.conf.d/"$_name" ] ; then
1341				local _rc
1342				for _rc in ${_d}/rc.conf.d/"$_name"/* ; do
1343					if [ -f "$_rc" ] ; then
1344						debug "Sourcing $_rc"
1345						. "$_rc"
1346					fi
1347				done
1348			fi
1349		done
1350	fi
1351
1352	# Set defaults if defined.
1353	for _var in $rcvar $rcvars; do
1354		eval _defval=\$${_var}_defval
1355		if [ -n "$_defval" ]; then
1356			eval : \${$_var:=\$${_var}_defval}
1357		fi
1358	done
1359
1360	# check obsolete rc.conf variables
1361	for _var in $rcvars_obsolete; do
1362		eval _v=\$$_var
1363		eval _msg=\$${_var}_obsolete_msg
1364		eval _new=\$${_var}_newvar
1365		case $_v in
1366		"")
1367			;;
1368		*)
1369			if [ -z "$_new" ]; then
1370				_msg="Ignored."
1371			else
1372				eval $_new=\"\$$_var\"
1373				if [ -z "$_msg" ]; then
1374					_msg="Use \$$_new instead."
1375				fi
1376			fi
1377			warn "\$$_var is obsolete.  $_msg"
1378			;;
1379		esac
1380	done
1381}
1382
1383#
1384# load_rc_config_var name var
1385#	Read the rc.conf(5) var for name and set in the
1386#	current shell, using load_rc_config in a subshell to prevent
1387#	unwanted side effects from other variable assignments.
1388#
1389load_rc_config_var()
1390{
1391	if [ $# -ne 2 ]; then
1392		err 3 'USAGE: load_rc_config_var name var'
1393	fi
1394	eval $(eval '(
1395		load_rc_config '$1' >/dev/null;
1396                if [ -n "${'$2'}" -o "${'$2'-UNSET}" != "UNSET" ]; then
1397			echo '$2'=\'\''${'$2'}\'\'';
1398		fi
1399	)' )
1400}
1401
1402#
1403# rc_usage commands
1404#	Print a usage string for $0, with `commands' being a list of
1405#	valid commands.
1406#
1407rc_usage()
1408{
1409	echo -n 1>&2 "Usage: $0 [fast|force|one|quiet]("
1410
1411	_sep=
1412	for _elem; do
1413		echo -n 1>&2 "$_sep$_elem"
1414		_sep="|"
1415	done
1416	echo 1>&2 ")"
1417	exit 1
1418}
1419
1420#
1421# err exitval message
1422#	Display message to stderr and log to the syslog, and exit with exitval.
1423#
1424err()
1425{
1426	exitval=$1
1427	shift
1428
1429	if [ -x /usr/bin/logger ]; then
1430		logger "$0: ERROR: $*"
1431	fi
1432	echo 1>&2 "$0: ERROR: $*"
1433	exit $exitval
1434}
1435
1436#
1437# warn message
1438#	Display message to stderr and log to the syslog.
1439#
1440warn()
1441{
1442	if [ -x /usr/bin/logger ]; then
1443		logger "$0: WARNING: $*"
1444	fi
1445	echo 1>&2 "$0: WARNING: $*"
1446}
1447
1448#
1449# info message
1450#	Display informational message to stdout and log to syslog.
1451#
1452info()
1453{
1454	case ${rc_info} in
1455	[Yy][Ee][Ss]|[Tt][Rr][Uu][Ee]|[Oo][Nn]|1)
1456		if [ -x /usr/bin/logger ]; then
1457			logger "$0: INFO: $*"
1458		fi
1459		echo "$0: INFO: $*"
1460		;;
1461	esac
1462}
1463
1464#
1465# debug message
1466#	If debugging is enabled in rc.conf output message to stderr.
1467#	BEWARE that you don't call any subroutine that itself calls this
1468#	function.
1469#
1470debug()
1471{
1472	case ${rc_debug} in
1473	[Yy][Ee][Ss]|[Tt][Rr][Uu][Ee]|[Oo][Nn]|1)
1474		if [ -x /usr/bin/logger ]; then
1475			logger "$0: DEBUG: $*"
1476		fi
1477		echo 1>&2 "$0: DEBUG: $*"
1478		;;
1479	esac
1480}
1481
1482#
1483# backup_file action file cur backup
1484#	Make a backup copy of `file' into `cur', and save the previous
1485#	version of `cur' as `backup' or use rcs for archiving.
1486#
1487#	This routine checks the value of the backup_uses_rcs variable,
1488#	which can be either YES or NO.
1489#
1490#	The `action' keyword can be one of the following:
1491#
1492#	add		`file' is now being backed up (and is possibly
1493#			being reentered into the backups system).  `cur'
1494#			is created and RCS files, if necessary, are
1495#			created as well.
1496#
1497#	update		`file' has changed and needs to be backed up.
1498#			If `cur' exists, it is copied to to `back' or
1499#			checked into RCS (if the repository file is old),
1500#			and then `file' is copied to `cur'.  Another RCS
1501#			check in done here if RCS is being used.
1502#
1503#	remove		`file' is no longer being tracked by the backups
1504#			system.  If RCS is not being used, `cur' is moved
1505#			to `back', otherwise an empty file is checked in,
1506#			and then `cur' is removed.
1507#
1508#
1509backup_file()
1510{
1511	_action=$1
1512	_file=$2
1513	_cur=$3
1514	_back=$4
1515
1516	if checkyesno backup_uses_rcs; then
1517		_msg0="backup archive"
1518		_msg1="update"
1519
1520		# ensure that history file is not locked
1521		if [ -f $_cur,v ]; then
1522			rcs -q -u -U -M $_cur
1523		fi
1524
1525		# ensure after switching to rcs that the
1526		# current backup is not lost
1527		if [ -f $_cur ]; then
1528			# no archive, or current newer than archive
1529			if [ ! -f $_cur,v -o $_cur -nt $_cur,v ]; then
1530				ci -q -f -u -t-"$_msg0" -m"$_msg1" $_cur
1531				rcs -q -kb -U $_cur
1532				co -q -f -u $_cur
1533			fi
1534		fi
1535
1536		case $_action in
1537		add|update)
1538			cp -p $_file $_cur
1539			ci -q -f -u -t-"$_msg0" -m"$_msg1" $_cur
1540			rcs -q -kb -U $_cur
1541			co -q -f -u $_cur
1542			chown root:wheel $_cur $_cur,v
1543			;;
1544		remove)
1545			cp /dev/null $_cur
1546			ci -q -f -u -t-"$_msg0" -m"$_msg1" $_cur
1547			rcs -q -kb -U $_cur
1548			chown root:wheel $_cur $_cur,v
1549			rm $_cur
1550			;;
1551		esac
1552	else
1553		case $_action in
1554		add|update)
1555			if [ -f $_cur ]; then
1556				cp -p $_cur $_back
1557			fi
1558			cp -p $_file $_cur
1559			chown root:wheel $_cur
1560			;;
1561		remove)
1562			mv -f $_cur $_back
1563			;;
1564		esac
1565	fi
1566}
1567
1568# make_symlink src link
1569#	Make a symbolic link 'link' to src from basedir. If the
1570#	directory in which link is to be created does not exist
1571#	a warning will be displayed and an error will be returned.
1572#	Returns 0 on success, 1 otherwise.
1573#
1574make_symlink()
1575{
1576	local src link linkdir _me
1577	src="$1"
1578	link="$2"
1579	linkdir="`dirname $link`"
1580	_me="make_symlink()"
1581
1582	if [ -z "$src" -o -z "$link" ]; then
1583		warn "$_me: requires two arguments."
1584		return 1
1585	fi
1586	if [ ! -d "$linkdir" ]; then
1587		warn "$_me: the directory $linkdir does not exist."
1588		return 1
1589	fi
1590	if ! ln -sf $src $link; then
1591		warn "$_me: unable to make a symbolic link from $link to $src"
1592		return 1
1593	fi
1594	return 0
1595}
1596
1597# devfs_rulesets_from_file file
1598#	Reads a set of devfs commands from file, and creates
1599#	the specified rulesets with their rules. Returns non-zero
1600#	if there was an error.
1601#
1602devfs_rulesets_from_file()
1603{
1604	local file _err _me _opts
1605	file="$1"
1606	_me="devfs_rulesets_from_file"
1607	_err=0
1608
1609	if [ -z "$file" ]; then
1610		warn "$_me: you must specify a file"
1611		return 1
1612	fi
1613	if [ ! -e "$file" ]; then
1614		debug "$_me: no such file ($file)"
1615		return 0
1616	fi
1617
1618	# Disable globbing so that the rule patterns are not expanded
1619	# by accident with matching filesystem entries.
1620	_opts=$-; set -f
1621
1622	debug "reading rulesets from file ($file)"
1623	{ while read line
1624	do
1625		case $line in
1626		\#*)
1627			continue
1628			;;
1629		\[*\]*)
1630			rulenum=`expr "$line" : "\[.*=\([0-9]*\)\]"`
1631			if [ -z "$rulenum" ]; then
1632				warn "$_me: cannot extract rule number ($line)"
1633				_err=1
1634				break
1635			fi
1636			rulename=`expr "$line" : "\[\(.*\)=[0-9]*\]"`
1637			if [ -z "$rulename" ]; then
1638				warn "$_me: cannot extract rule name ($line)"
1639				_err=1
1640				break;
1641			fi
1642			eval $rulename=\$rulenum
1643			debug "found ruleset: $rulename=$rulenum"
1644			if ! /sbin/devfs rule -s $rulenum delset; then
1645				_err=1
1646				break
1647			fi
1648			;;
1649		*)
1650			rulecmd="${line%%"\#*"}"
1651			# evaluate the command incase it includes
1652			# other rules
1653			if [ -n "$rulecmd" ]; then
1654				debug "adding rule ($rulecmd)"
1655				if ! eval /sbin/devfs rule -s $rulenum $rulecmd
1656				then
1657					_err=1
1658					break
1659				fi
1660			fi
1661			;;
1662		esac
1663		if [ $_err -ne 0 ]; then
1664			debug "error in $_me"
1665			break
1666		fi
1667	done } < $file
1668	case $_opts in *f*) ;; *) set +f ;; esac
1669	return $_err
1670}
1671
1672# devfs_init_rulesets
1673#	Initializes rulesets from configuration files. Returns
1674#	non-zero if there was an error.
1675#
1676devfs_init_rulesets()
1677{
1678	local file _me
1679	_me="devfs_init_rulesets"
1680
1681	# Go through this only once
1682	if [ -n "$devfs_rulesets_init" ]; then
1683		debug "$_me: devfs rulesets already initialized"
1684		return
1685	fi
1686	for file in $devfs_rulesets; do
1687		if ! devfs_rulesets_from_file $file; then
1688			warn "$_me: could not read rules from $file"
1689			return 1
1690		fi
1691	done
1692	devfs_rulesets_init=1
1693	debug "$_me: devfs rulesets initialized"
1694	return 0
1695}
1696
1697# devfs_set_ruleset ruleset [dir]
1698#	Sets the default ruleset of dir to ruleset. The ruleset argument
1699#	must be a ruleset name as specified in devfs.rules(5) file.
1700#	Returns non-zero if it could not set it successfully.
1701#
1702devfs_set_ruleset()
1703{
1704	local devdir rs _me
1705	[ -n "$1" ] && eval rs=\$$1 || rs=
1706	[ -n "$2" ] && devdir="-m "$2"" || devdir=
1707	_me="devfs_set_ruleset"
1708
1709	if [ -z "$rs" ]; then
1710		warn "$_me: you must specify a ruleset number"
1711		return 1
1712	fi
1713	debug "$_me: setting ruleset ($rs) on mount-point (${devdir#-m })"
1714	if ! /sbin/devfs $devdir ruleset $rs; then
1715		warn "$_me: unable to set ruleset $rs to ${devdir#-m }"
1716		return 1
1717	fi
1718	return 0
1719}
1720
1721# devfs_apply_ruleset ruleset [dir]
1722#	Apply ruleset number $ruleset to the devfs mountpoint $dir.
1723#	The ruleset argument must be a ruleset name as specified
1724#	in a devfs.rules(5) file.  Returns 0 on success or non-zero
1725#	if it could not apply the ruleset.
1726#
1727devfs_apply_ruleset()
1728{
1729	local devdir rs _me
1730	[ -n "$1" ] && eval rs=\$$1 || rs=
1731	[ -n "$2" ] && devdir="-m "$2"" || devdir=
1732	_me="devfs_apply_ruleset"
1733
1734	if [ -z "$rs" ]; then
1735		warn "$_me: you must specify a ruleset"
1736		return 1
1737	fi
1738	debug "$_me: applying ruleset ($rs) to mount-point (${devdir#-m })"
1739	if ! /sbin/devfs $devdir rule -s $rs applyset; then
1740		warn "$_me: unable to apply ruleset $rs to ${devdir#-m }"
1741		return 1
1742	fi
1743	return 0
1744}
1745
1746# devfs_domount dir [ruleset]
1747#	Mount devfs on dir. If ruleset is specified it is set
1748#	on the mount-point. It must also be a ruleset name as specified
1749#	in a devfs.rules(5) file. Returns 0 on success.
1750#
1751devfs_domount()
1752{
1753	local devdir rs _me
1754	devdir="$1"
1755	[ -n "$2" ] && rs=$2 || rs=
1756	_me="devfs_domount()"
1757
1758	if [ -z "$devdir" ]; then
1759		warn "$_me: you must specify a mount-point"
1760		return 1
1761	fi
1762	debug "$_me: mount-point is ($devdir), ruleset is ($rs)"
1763	if ! mount -t devfs dev "$devdir"; then
1764		warn "$_me: Unable to mount devfs on $devdir"
1765		return 1
1766	fi
1767	if [ -n "$rs" ]; then
1768		devfs_init_rulesets
1769		devfs_set_ruleset $rs $devdir
1770		devfs -m $devdir rule applyset
1771	fi
1772	return 0
1773}
1774
1775# Provide a function for normalizing the mounting of memory
1776# filesystems.  This should allow the rest of the code here to remain
1777# as close as possible between 5-current and 4-stable.
1778#   $1 = size
1779#   $2 = mount point
1780#   $3 = (optional) extra mdmfs flags
1781mount_md()
1782{
1783	if [ -n "$3" ]; then
1784		flags="$3"
1785	fi
1786	/sbin/mdmfs $flags -s $1 md $2
1787}
1788
1789# Code common to scripts that need to load a kernel module
1790# if it isn't in the kernel yet. Syntax:
1791#   load_kld [-e regex] [-m module] file
1792# where -e or -m chooses the way to check if the module
1793# is already loaded:
1794#   regex is egrep'd in the output from `kldstat -v',
1795#   module is passed to `kldstat -m'.
1796# The default way is as though `-m file' were specified.
1797load_kld()
1798{
1799	local _loaded _mod _opt _re
1800
1801	while getopts "e:m:" _opt; do
1802		case "$_opt" in
1803		e) _re="$OPTARG" ;;
1804		m) _mod="$OPTARG" ;;
1805		*) err 3 'USAGE: load_kld [-e regex] [-m module] file' ;;
1806		esac
1807	done
1808	shift $(($OPTIND - 1))
1809	if [ $# -ne 1 ]; then
1810		err 3 'USAGE: load_kld [-e regex] [-m module] file'
1811	fi
1812	_mod=${_mod:-$1}
1813	_loaded=false
1814	if [ -n "$_re" ]; then
1815		if kldstat -v | egrep -q -e "$_re"; then
1816			_loaded=true
1817		fi
1818	else
1819		if kldstat -q -m "$_mod"; then
1820			_loaded=true
1821		fi
1822	fi
1823	if ! $_loaded; then
1824		if ! kldload "$1"; then
1825			warn "Unable to load kernel module $1"
1826			return 1
1827		else
1828			info "$1 kernel module loaded."
1829		fi
1830	else
1831		debug "load_kld: $1 kernel module already loaded."
1832	fi
1833	return 0
1834}
1835
1836# ltr str src dst [var]
1837#	Change every $src in $str to $dst.
1838#	Useful when /usr is not yet mounted and we cannot use tr(1), sed(1) nor
1839#	awk(1). If var is non-NULL, set it to the result.
1840ltr()
1841{
1842	local _str _src _dst _out _com _var
1843	_str="$1"
1844	_src="$2"
1845	_dst="$3"
1846	_var="$4"
1847	_out=""
1848
1849	local IFS="${_src}"
1850	for _com in ${_str}; do
1851		if [ -z "${_out}" ]; then
1852			_out="${_com}"
1853		else
1854			_out="${_out}${_dst}${_com}"
1855		fi
1856	done
1857	if [ -n "${_var}" ]; then
1858		setvar "${_var}" "${_out}"
1859	else
1860		echo "${_out}"
1861	fi
1862}
1863
1864# Creates a list of providers for GELI encryption.
1865geli_make_list()
1866{
1867	local devices devices2
1868	local provider mountpoint type options rest
1869
1870	# Create list of GELI providers from fstab.
1871	while read provider mountpoint type options rest ; do
1872		case ":${options}" in
1873		:*noauto*)
1874			noauto=yes
1875			;;
1876		*)
1877			noauto=no
1878			;;
1879		esac
1880
1881		case ":${provider}" in
1882		:#*)
1883			continue
1884			;;
1885		*.eli)
1886			# Skip swap devices.
1887			if [ "${type}" = "swap" -o "${options}" = "sw" -o "${noauto}" = "yes" ]; then
1888				continue
1889			fi
1890			devices="${devices} ${provider}"
1891			;;
1892		esac
1893	done < /etc/fstab
1894
1895	# Append providers from geli_devices.
1896	devices="${devices} ${geli_devices}"
1897
1898	for provider in ${devices}; do
1899		provider=${provider%.eli}
1900		provider=${provider#/dev/}
1901		devices2="${devices2} ${provider}"
1902	done
1903
1904	echo ${devices2}
1905}
1906
1907# Find scripts in local_startup directories that use the old syntax
1908#
1909find_local_scripts_old() {
1910	zlist=''
1911	slist=''
1912	for dir in ${local_startup}; do
1913		if [ -d "${dir}" ]; then
1914			for file in ${dir}/[0-9]*.sh; do
1915				grep '^# PROVIDE:' $file >/dev/null 2>&1 &&
1916				    continue
1917				zlist="$zlist $file"
1918			done
1919			for file in ${dir}/[!0-9]*.sh; do
1920				grep '^# PROVIDE:' $file >/dev/null 2>&1 &&
1921				    continue
1922				slist="$slist $file"
1923			done
1924		fi
1925	done
1926}
1927
1928find_local_scripts_new() {
1929	local_rc=''
1930	for dir in ${local_startup}; do
1931		if [ -d "${dir}" ]; then
1932			for file in `grep -l '^# PROVIDE:' ${dir}/* 2>/dev/null`; do
1933				case "$file" in
1934				*.sample) ;;
1935				*)	if [ -x "$file" ]; then
1936						local_rc="${local_rc} ${file}"
1937					fi
1938					;;
1939				esac
1940			done
1941		fi
1942	done
1943}
1944
1945# check_required_{before|after} command
1946#	Check for things required by the command before and after its precmd,
1947#	respectively.  The two separate functions are needed because some
1948#	conditions should prevent precmd from being run while other things
1949#	depend on precmd having already been run.
1950#
1951check_required_before()
1952{
1953	local _f
1954
1955	case "$1" in
1956	start)
1957		for _f in $required_vars; do
1958			if ! checkyesno $_f; then
1959				warn "\$${_f} is not enabled."
1960				if [ -z "$rc_force" ]; then
1961					return 1
1962				fi
1963			fi
1964		done
1965
1966		for _f in $required_dirs; do
1967			if [ ! -d "${_f}/." ]; then
1968				warn "${_f} is not a directory."
1969				if [ -z "$rc_force" ]; then
1970					return 1
1971				fi
1972			fi
1973		done
1974
1975		for _f in $required_files; do
1976			if [ ! -r "${_f}" ]; then
1977				warn "${_f} is not readable."
1978				if [ -z "$rc_force" ]; then
1979					return 1
1980				fi
1981			fi
1982		done
1983		;;
1984	esac
1985
1986	return 0
1987}
1988
1989check_required_after()
1990{
1991	local _f _args
1992
1993	case "$1" in
1994	start)
1995		for _f in $required_modules; do
1996			case "${_f}" in
1997				*~*)	_args="-e ${_f#*~} ${_f%%~*}" ;;
1998				*:*)	_args="-m ${_f#*:} ${_f%%:*}" ;;
1999				*)	_args="${_f}" ;;
2000			esac
2001			if ! load_kld ${_args}; then
2002				if [ -z "$rc_force" ]; then
2003					return 1
2004				fi
2005			fi
2006		done
2007		;;
2008	esac
2009
2010	return 0
2011}
2012
2013# check_jail mib
2014#	Return true if security.jail.$mib exists and set to 1.
2015
2016check_jail()
2017{
2018	local _mib _v
2019
2020	_mib=$1
2021	if _v=$(${SYSCTL_N} "security.jail.$_mib" 2> /dev/null); then
2022		case $_v in
2023		1)	return 0;;
2024		esac
2025	fi
2026	return 1
2027}
2028
2029# check_kern_features mib
2030#	Return existence of kern.features.* sysctl MIB as true or
2031#	false.  The result will be cached in $_rc_cache_kern_features_
2032#	namespace.  "0" means the kern.features.X exists.
2033
2034check_kern_features()
2035{
2036	local _v
2037
2038	[ -n "$1" ] || return 1;
2039	eval _v=\$_rc_cache_kern_features_$1
2040	[ -n "$_v" ] && return "$_v";
2041
2042	if ${SYSCTL_N} kern.features.$1 > /dev/null 2>&1; then
2043		eval _rc_cache_kern_features_$1=0
2044		return 0
2045	else
2046		eval _rc_cache_kern_features_$1=1
2047		return 1
2048	fi
2049}
2050
2051# check_namevarlist var
2052#	Return "0" if ${name}_var is reserved in rc.subr.
2053
2054_rc_namevarlist="program chroot chdir env flags fib nice user group groups prepend"
2055check_namevarlist()
2056{
2057	local _v
2058
2059	for _v in $_rc_namevarlist; do
2060	case $1 in
2061	$_v)	return 0 ;;
2062	esac
2063	done
2064
2065	return 1
2066}
2067
2068# _echoonce var msg mode
2069#	mode=0: Echo $msg if ${$var} is empty.
2070#	        After doing echo, a string is set to ${$var}.
2071#
2072#	mode=1: Echo $msg if ${$var} is a string with non-zero length.
2073#
2074_echoonce()
2075{
2076	local _var _msg _mode
2077	eval _var=\$$1
2078	_msg=$2
2079	_mode=$3
2080
2081	case $_mode in
2082	1)	[ -n "$_var" ] && echo "$_msg" ;;
2083	*)	[ -z "$_var" ] && echo -n "$_msg" && eval "$1=finished" ;;
2084	esac
2085}
2086
2087fi # [ -z "${_rc_subr_loaded}" ]
2088
2089_rc_subr_loaded=:
2090